﻿using C1.Win.C1TrueDBGrid;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace Tutor13
{
    public class ScrollServices: IDisposable
    {
        private Timer _timer;
        private Point _position;
        private C1TrueDBGrid _grid;

        public ScrollServices(C1TrueDBGrid grid, int interval = 100)
        {
            _grid = grid;
            _grid.DragEnter += Grid_DragEnter;
            _grid.DragDrop += Grid_DragDrop;
            _grid.DragLeave += Grid_DragLeave;
            _grid.DragOver += Grid_DragOver;
            _timer = new Timer();
            _timer.Interval = interval;
            _timer.Tick += Timer_Tick;
        }

        public void Dispose()
        {
            if (_timer != null)
            {
                _timer.Enabled = false;
                _timer.Tick -= Timer_Tick;
                _timer = null;
            }
            if (_grid != null)
            {
                _grid.DragEnter -= Grid_DragEnter;
                _grid.DragDrop -= Grid_DragDrop;
                _grid.DragLeave -= Grid_DragLeave;
                _grid.DragOver -= Grid_DragOver;
                _grid = null;
            }            
        }

        private void Grid_DragOver(object sender, DragEventArgs e)
        {
            _position = new Point(e.X, e.Y);
        }

        private void Grid_DragLeave(object sender, EventArgs e)
        {
            _timer.Enabled = false;
        }

        private void Grid_DragDrop(object sender, DragEventArgs e)
        {
            _timer.Enabled = false;
        }

        private void Grid_DragEnter(object sender, DragEventArgs e)
        {
            _timer.Enabled = true;
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            var point = _grid.PointToClient(_position);
            var dy = 5;
            if (_grid.RowHeight + dy >= point.Y)
                _grid.ScrollGrid(0, -1);
            if (_grid.Bounds.Height - dy <= point.Y)
                _grid.ScrollGrid(0, 1);            
        }
    }
}
